try {
    FB.init({
        appId: fbAppId,
        status: true, // check login status
        cookie: true, // enable cookies to allow the server to access the session
        xfbml: true,  // parse XFBML
        version: 'v2.9'
    });
    FB.Event.subscribe('auth.authResponseChange', function (response) {
        try {
            if (response.status === 'connected') {
                PizapLogin.handleFBLoginResponse(response);
            } else if (response.status === 'not_authorized') {
                if (isPizapBook && !displayPublic) {
                    top.location.href = 'https://www.facebook.com/appcenter/' + fbNamespace + "?redirect_uri=" + encodeURI(window.location);
                }
            } else {
                if (isPizapBook && !displayPublic) {
                    top.location.href = 'https://www.facebook.com/appcenter/' + fbNamespace + "?redirect_uri=" + encodeURI(window.location);
                }
            }
            if (isPizapBook)
                FB.Canvas.scrollTo(0, 0);
            if (window.self !== window.top)
                FB.Canvas.setAutoGrow();
            try {
                page_defer();
            } catch (e) {
            }
        } catch (err) {
            logError("authResponseChange", err);
        }
    });

}catch(err){
    logError("FB.init", err);
}
var sonicUpgradeId;
window.showStore = function(typeId, upgradeCode) {
    showPRODialog();
//    sonicUpgradeId = upgradeCode;
//    if(upgradeCode && upgradeCode > 0){
//        document.getElementById("store-unlock").style.display = "block";
//        if(!sonicLoaded){
//            sonicLoaded = true;
//            var el = document.createElement('SCRIPT');
//            el.setAttribute('src', ('https:' != location.protocol ? 'http://jsd.supersonicads.com' : 'https://a248.e.akamai.net/ssastatic.s3.amazonaws.com') + '/inlineDelivery/delivery.min.gz.js');

//            el.addEventListener('load', function () {
//                sonicOnLoaded();
//            }, false);

//            var bodyEl = document.getElementsByTagName('BODY')[0];
//            bodyEl.appendChild(el);
//        }
//        createConnection();
//    }else{
    document.getElementById("store-unlock").style.display = "none";
//    }
};



var docCookies = {
    getItem: function (sKey) {
        if (!sKey) { return null; }
        return decodeURIComponent(document.cookie.replace(new RegExp("(?:(?:^|.*;)\\s*" + encodeURIComponent(sKey).replace(/[\-\.\+\*]/g, "\\$&") + "\\s*\\=\\s*([^;]*).*$)|^.*$"), "$1")) || null;
    },
    setItem: function (sKey, sValue, vEnd, sPath, sDomain, bSecure) {
        if (!sKey || /^(?:expires|max\-age|path|domain|secure)$/i.test(sKey)) { return false; }
        var sExpires = "";
        if (vEnd) {
            switch (vEnd.constructor) {
                case Number:
                    sExpires = vEnd === Infinity ? "; expires=Fri, 31 Dec 9999 23:59:59 GMT" : "; max-age=" + vEnd;
                    break;
                case String:
                    sExpires = "; expires=" + vEnd;
                    break;
                case Date:
                    sExpires = "; expires=" + vEnd.toUTCString();
                    break;
            }
        }
        document.cookie = encodeURIComponent(sKey) + "=" + encodeURIComponent(sValue) + sExpires + (sDomain ? "; domain=" + sDomain : "") + (sPath ? "; path=" + sPath : "") + (bSecure ? "; secure" : "");
        return true;
    },
    removeItem: function (sKey, sPath, sDomain) {
        if (!this.hasItem(sKey)) { return false; }
        document.cookie = encodeURIComponent(sKey) + "=; expires=Thu, 01 Jan 1970 00:00:00 GMT" + (sDomain ? "; domain=" + sDomain : "") + (sPath ? "; path=" + sPath : "");
        return true;
    },
    hasItem: function (sKey) {
        if (!sKey) { return false; }
        return (new RegExp("(?:^|;\\s*)" + encodeURIComponent(sKey).replace(/[\-\.\+\*]/g, "\\$&") + "\\s*\\=")).test(document.cookie);
    },
    keys: function () {
        var aKeys = document.cookie.replace(/((?:^|\s*;)[^\=]+)(?=;|$)|^\s*|\s*(?:\=[^;]*)?(?:\1|$)/g, "").split(/\s*(?:\=[^;]*)?;\s*/);
        for (var nLen = aKeys.length, nIdx = 0; nIdx < nLen; nIdx++) { aKeys[nIdx] = decodeURIComponent(aKeys[nIdx]); }
        return aKeys;
    }
};

var eventbusUrl = 'https://eventbus.pizap.com/eb';
var eb;
var sonicLoaded = false;
var uuid = docCookies.getItem("sonicId");
if(!uuid) {
    uuid = guid();
    docCookies.setItem("sonicId", uuid, Infinity);
}

function guid() {
    function s4() {
        return Math.floor((1 + Math.random()) * 0x10000)
            .toString(16)
            .substring(1);
    }
    return s4() + s4() + '-' + s4() + '-' + s4() + '-' +
        s4() + '-' + s4() + s4() + s4();
}

function sonicOnLoaded(){
}

var ssa_json = { 'applicationUserId' : uuid, 'applicationKey' : '413fd6c5',
    'onCampaignsReady': brandConnectReadyEvent,
    'onCampaignsDone': brandConnectDoneEvent, // will be fired when user completed all the available offers
    'onCampaignOpen': myBrandConnectOpenEvent, // will be fired every time an offer was opened
    'onCampaignClose': myBrandConnectCloseEvent, // will be fired every time an offer was closed
    'onCampaignCompleted': myBrandConnectCompletedEvent,
    pagination: false
};


// will be fired upon engagement open
function myBrandConnectOpenEvent(offer){

    // log the event on js console
    log('opened', offer);

    // optional - hidding the button when the engagmewnt is opened
    hideBrandConnectButton();

}

// will be fired upon engagement close
function myBrandConnectCloseEvent(offer){
    showBrandConnectButton();
}

// will be fired upon engagement completion
function myBrandConnectCompletedEvent(offer){
    log('onCampaignCompleted: ',offer);
    if(sonicUpgradeId){
        var flashMovie = getFlashMovieObject('flashContent');

        if (flashMovie) {
            try {
                flashMovie.unlockStoreItem(sonicUpgradeId);
            } catch (e) {}
        }
    }
}

// will be fired when ALL engagements were completed
function brandConnectDoneEvent(){
    hideBrandConnectButton();
}

// will be fired when BrandConnect engagments are ready
function brandConnectReadyEvent(engagments){
    if(typeof engagments !== 'undefined' && engagments.length){
        showBrandConnectButton();
    }
}

function showBrandConnectButton(){
    document.getElementById("store-unlock").style.display = "block";
}

function hideBrandConnectButton(){
    document.getElementById("store-unlock").style.display = "none";
}

function log(msg){
    var log = (typeof console !== 'undefined' && typeof console.log !== 'undefined');
    log && console.log(msg);
}


function consumeOffer(index){
    var overlay = document.getElementById("adOverlay");

    SSA_CORE.BrandConnect.engage();
}





// show store dialog
function showPRODialog() {
    var overlayEl = document.getElementById('store-overlay');
    var dialogEl = document.getElementById('store-dialog');
    dialogEl.classList.add('active');
    overlayEl.classList.add('active');
    fbq('track', 'ViewContent', {
        value: 4.99,
        currency: 'USD'
    });

}

// hide store dialog
function hidePRODialog() {
    var dialogEl = document.getElementById('store-dialog');
    dialogEl.classList.remove('active');
}

// hide overlay
function hidePROOverlay() {
    var overlayEl = document.getElementById('store-overlay');
    overlayEl.classList.remove('active');
}
var closeBtnEl = document.getElementById('store-close-btn');
closeBtnEl.addEventListener('click', function() {
    hidePRODialog();
    hidePROOverlay();
}, false);


function purchasePRO(duration){
    if (username && username != '') {
        var url = 'http://' + recurlySubDomain + '.recurly.com/subscribe/pro-' + duration + '/' + username;
        var win = window.open(url, '_blank');
        win.focus();
        fbq('track', 'InitiateCheckout');
    }else{
        hidePRODialog();
        hidePROOverlay();
        postLoginUrl = 'http://' + recurlySubDomain + '.recurly.com/subscribe/pro-' + duration + '/';
        PizapLogin.showLoginDialog();
    }
}

function isVisible(obj)
{
    if (obj == document) return true;

    if (!obj) return false;
    if (!obj.parentNode) return false;
    if (obj.style) {
        if (obj.style.display == 'none') return false;
        if (obj.style.visibility == 'hidden') return false;
    }

    //Try the computed style in a standard way
    if (window.getComputedStyle) {
        var style = window.getComputedStyle(obj, "");
        if (style.display == 'none') return false;
        if (style.visibility == 'hidden') return false;
    }

    //Or get the computed style using IE's silly proprietary way
    var style = obj.currentStyle;
    if (style) {
        if (style['display'] == 'none') return false;
        if (style['visibility'] == 'hidden') return false;
    }

    return isVisible(obj.parentNode);
}

function getJSON(url, methodType, myData, successHandler, errorHandler)
{
    var xhr = typeof XMLHttpRequest != 'undefined'
        ? new XMLHttpRequest()
        : new ActiveXObject('Microsoft.XMLHTTP');
    xhr.open(methodType, url, true);
    xhr.onreadystatechange = function() {
        var status;
        var data;
        // http://xhr.spec.whatwg.org/#dom-xmlhttprequest-readystate
        if (xhr.readyState == 4) { // `DONE`
            status = xhr.status;
            if (status == 200) {
                try{
                    data = JSON.parse(xhr.responseText);
                    successHandler && successHandler(data);
                }catch(e){
                    successHandler && successHandler(xhr.responseText);
                }
            } else {
                errorHandler && errorHandler(status);
            }
        }
    };
    xhr.setRequestHeader("Content-type", "application/x-www-form-urlencoded; charset=UTF-8");
    if(myData != null)
        xhr.send(myData);
    else
        xhr.send();
}

function openIframeDiv(url){

}


function getFlashMovieObject2(movieName){
    if (window.document[movieName]){
        return window.document[movieName];
    }
    if (navigator.appName.indexOf("Microsoft Internet")==-1){
        if (document.embeds && document.embeds[movieName])
            return document.embeds[movieName];
    }
    else{
        return document.getElementById(movieName);
    }
}

function activate(id) {
    var el = document.getElementById(id);

    if (! el) { return null; }

    el.className = el.className.replace('active', '') + ' active';
}

function deactivate(id) {
    var el = document.getElementById(id);

    if (! el) { return null; }

    el.className = el.className.replace('active', '');
}

function show(id) {
    var el = document.getElementById(id);

    if (! el) { return null; }

    el.style.display = '';
}

function hide(id) {
    var el = document.getElementById(id);

    if (! el) { return null; }

    el.style.display = 'none';
}

function hideAll() {
    hide('sign-popup-in');
    hide('sign-popup-up');
    hide('sign-popup-restore');
}

var Sign = {
    showLoginDialog: function(network, permission)
    {
        activate('sign-popup');
        activate('sign-overlay');
        hideAll();
        show('sign-popup-in');

        switch (network) {
            case 'facebook':
                if (permission) {
                    Sign.showFacebook(permission);
                } else {
                    Sign.showFacebook();
                }
                break;
            case 'twitter':
                Sign.showTwitter();
                break;
            case 'google':
                Sign.showGoogle();
                break;
        }
    },

    hideLoginDialog: function()
    {
        deactivate('sign-popup');
        deactivate('sign-overlay');
        hideAll();
    },

    showRegisterDialog: function()
    {
        activate('sign-popup');
        activate('sign-overlay');
        hideAll();
        show('sign-popup-up');
    },

    passwordReset: function()
    {
        activate('sign-popup');
        activate('sign-overlay');
        hideAll();
        show('sign-popup-restore');
    },

    getUser: function(callback)
    {
        if (typeof callback !== 'function') {
            return;
        }

        getJSON('/me', 'GET', null, callback);
    },

    resetLogin: function()
    {
        var signInForm = document.getElementById('sign-in-form');
        var signUpForm = document.getElementById('sign-up-form');
        var signRestoreForm = document.getElementById('sign-restore-form');

        if (signInForm) {
            signInForm.reset();
        }

        if (signUpForm) {
            signUpForm.reset();
        }

        if (signRestoreForm) {
            signRestoreForm.reset();
        }
    },

    pizapLogin: function()
    {
        var form = document.getElementById('sign-in-form');

        if (! form.checkValidity()) {
            return;
        }

        var username = document.getElementById('sign-in-username');
        var password = document.getElementById('sign-in-password');

        var myData = 'isajax=1&username='
            + encodeURIComponent(username.value)
            + '&password=' + encodeURIComponent(password.value);

        getJSON('/login', 'POST', myData, function(data){
            if (typeof data.Error !== 'undefined' && data.Error) {
                alert(data.Error);
                return;
            }

            Sign.hideLoginDialog();
            Sign.resetLogin();

            if (!isPizapBook) {
                //if (editorPage == true) {
                Sign.updateHeader(data);
                return;
            }

            if (isPizapBook) {
                top.location.href='//apps.facebook.com/' + fbNamespace + "/gallery/following";
            }
//            else{
//              window.location.href = "/gallery/following";
//            }
        });

        return false;
    },

    restore: function()
    {
        var username = document.getElementById('sign-restore-username');

        var myData = 'isajax=1&username=' + encodeURIComponent(username.value);

        getJSON('/change_password', 'POST', myData, function(data) {
            if (data.Error) {
                alert(data.Error);
                return;
            }

            alert(data.Success);
            Sign.hideLoginDialog();
            Sign.resetLogin();
        });
    },

    register: function(){
        var username     = document.getElementById('sign-up-username');
        var password     = document.getElementById('sign-up-password');
        var email        = document.getElementById('sign-up-email');
        var emailconfirm = document.getElementById('sign-up-emailconfirm');

        var myData = 'isajax=1&username=' + encodeURIComponent(username.value)
            + '&password=' + encodeURIComponent(password.value)
            + '&email=' + encodeURIComponent(email.value)
            + '&email_c=' + encodeURIComponent(emailconfirm.value)
            + '&password_c=' + encodeURIComponent(password.value);

        getJSON('/register', 'POST', myData, function(data){
            if (typeof data.Error !== 'undefined' && data.Error){
                alert(data.Error);
                typeof console !== 'undefined' && console.log(data.Error);
                return;
            }

            Sign.hideLoginDialog();
            Sign.resetLogin();

            if (editorPage == true) {
                Sign.updateHeader(data);
                return;
            }

            if (isPizapBook) {
                top.location.href = '//apps.facebook.com/' + fbNamespace + "/gallery/following";
            } else {
                window.location.href = "/gallery/following";
            }
        });
    },

    updateHeader: function(data)
    {
        var userMenu = document.getElementsByClassName('navbar1-login');
        if(userMenu && userMenu.length > 0) userMenu = userMenu[0];
        if(!data || data.UserName == undefined) return;
        if(data && data.UserName){
            username = data.UserName;
        }

        if (userMenu){
            var name = data.Name ? data.Name: data.UserName;
            var d = "<span class='menu-item user-item'><a href='/gallery/mypizap'><i class='icon1 icon-user1' style='background-image: url(" + data.ProfileImage + ");'></i>" + name + "</a></span>";
            userMenu.innerHTML = d;
        }
        var menuActions = document.getElementById('menuActionsEditor');
        if(menuActions){
            var name = data.Name ? data.Name: data.UserName;
            var e = '<div class="navbar-menu" style="width:190px; text-align:right; position: relative; font-size: 12px; white-space: nowrap"> <span><a href="/gallery/mypizap"><i class="icon1 icon-user1" style="background-image: url(' + data.ProfileImage + ');height:20px;width:20px"></i>' + name + '</a></span> </div>';
            menuActions.innerHTML = e;
        }

        if(postLoginUrl != null && username && username != ''){
            top.location.href = postLoginUrl + username;
        }
        var flashMovie = getFlashMovieObject('flashContent');

        if (flashMovie) {
            try {
                FB.api('/me/permissions', function (response) {
                    if (flashMovie) {
                        try {
                            data.permissions = response;
                            flashMovie.userLoggedIn(data);
                        } catch (e) {
                        }
                    }
                });
            } catch (e) {
                try {
                    flashMovie.userLoggedIn(data);
                } catch (e) {
                }
            }
        }
    },

    facebookPermission:function()
    {
        var flashMovie = getFlashMovieObject("flashContent");

        FB.getLoginStatus(function(response) {
            if (response.status === 'connected') {
                FB.api('/me/permissions', function(response){
                    if(flashMovie){
                        try {
                            flashMovie.facebookPermissionResponse(response);
                        } catch (e) { typeof console !== 'undefined' && console.log(e); }
                    }
                });
            } else if (response.status === 'not_authorized') {
                if(flashMovie){
                    try {
                        flashMovie.facebookPermissionResponse(response);
                    } catch (e) { typeof console !== 'undefined' && console.log(e); }
                }
            } else {
                if (flashMovie) {
                    try {
                        flashMovie.facebookPermissionResponse(response);
                    } catch (e) { typeof console !== 'undefined' && console.log(e); }
                }
            }
        });
    },

    showTwitter: function()
    {
        var left = (screen.width/2)-(400);
        var top = (screen.height/2)-(300);
        var win = window.open("/twitter/login?dialog=true",'','width=800,height=500,top='+top+',left='+left);
    },

    showFacebook: function(permission)
    {
        if(permission) {
            FB.login(function(response) {}, {scope: 'email,' + permission});
        } else {
            FB.login(function(response) {}, {scope: 'email'});
        }
    },

    showGoogle: function()
    {
        var left = (screen.width/2)-(400);
        var top = (screen.height/2)-(300);
        var win = window.location.href = "/gpluslogin?dialog=true";
    },

    setTwitterData: function(username, name)
    {
        Sign.hideLoginDialog();
        Sign.resetLogin();

        if (editorPage) {
            Sign.getUser(Sign.updateHeader);

            var flashMovie=getFlashMovieObject("flashContent");

            if (flashMovie) {
                try {
                    flashMovie.twitterAuthenticated(username);
                } catch(e) { }
            }
        } else {
            if (isPizapBook) {
                top.location.href='//apps.facebook.com/' + fbNamespace + "/gallery/following";
            } else {
                window.location.href = "/gallery/following";
            }
        }
    },

    setGPlusData: function(name)
    {
        Sign.hideLoginDialog();
        Sign.resetLogin();

        if (editorPage) {
            Sign.getUser(Sign.updateHeader);
        } else {
            if (isPizapBook){
                top.location.href='//apps.facebook.com/' + fbNamespace + "/gallery/following";
            } else {
                window.location.href = "/gallery/following";
            }
        }
    },

    handleFBLoginResponse: function(response)
    {
        if (response.status !== 'connected') {
            return;
        }

        FB.api('/'+response.authResponse.userID, function(data) {
            var email = "";
            if (data.email)
                email = data.email;

            Sign.hideLoginDialog();
            Sign.resetLogin();

            var myData = 'name=' + encodeURIComponent(data.name)
                + '&id='+encodeURIComponent(data.id)
                + '&email='+encodeURIComponent(email)
                + '&gender='+encodeURIComponent(data.gender)
                + '&token='+response.authResponse.accessToken;


            var xmlhttp = new XMLHttpRequest();

            xmlhttp.onload = function() {
//              if (! homePage){
                Sign.getUser(Sign.updateHeader);
//                return;
//              }

//              if (username != '') {
//                return;
//              }

//              if (isPizapBook) {
//                top.location.href='//apps.facebook.com/' + fbNamespace + "/gallery/following";
//              } else {
//                window.location.href = "/gallery/following";
//              }
            };

            xmlhttp.open("POST","/process_facebook",true);
            xmlhttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded; charset=UTF-8");
            xmlhttp.send(myData);
        });
    }
};

window.PizapLogin = Sign;



if(isPizapBook && !displayPublic){
    var container = document.getElementById("container");
    if(container){
        FB.Canvas.scrollTo(0,0);
        FB.Canvas.setAutoGrow();
        var interval = setInterval(function(){
            FB.Canvas.getPageInfo(
                function(info) {
                    var frameHeight = document.documentElement.clientHeight;
                    var offsetTop = info.offsetTop;
                    var scrollTop = info.scrollTop;
                    var fbTollernce = 1500;

                    if ((scrollTop + offsetTop >= frameHeight - fbTollernce)) {
                        infiniteScroll();
                    }
                });

        }, 100);
    }
}



var isMobile = {
    Android: function() {
        return navigator.userAgent.match(/Android/i);
    },
    BlackBerry: function() {
        return navigator.userAgent.match(/BlackBerry/i);
    },
    iOS: function() {
        return navigator.userAgent.match(/iPhone|iPad|iPod/i);
    },
    Opera: function() {
        return navigator.userAgent.match(/Opera Mini/i);
    },
    Windows: function() {
        return navigator.userAgent.match(/IEMobile/i);
    },
    any: function() {
        return (isMobile.Android() || isMobile.BlackBerry() || isMobile.iOS() || isMobile.Opera() || isMobile.Windows());
    }
};


if(document.getElementById('login-username')){
    document.getElementById('login-username').onkeyup = function(e){
        if(e.which == 13) {
            PizapLogin.pizapLogin();
        }
    };
    document.getElementById('login-password').onkeyup = function(e){
        if(e.which == 13) {
            PizapLogin.pizapLogin();
        }
    };
}

if(isMobile.iOS())
{
    var diviphone = document.getElementById("diviphone");
    if(diviphone)
        diviphone.style.visibility = "visible";
}
if(isMobile.Android())
{
    var divandroid = document.getElementById("divandroid");
    if(divandroid)
        divandroid.style.visibility = "visible";
}
if( isMobile.any() )
{
    var tdInviteFriends = document.getElementById("tdInviteFriends");
    var tdFBShare = document.getElementById("tdFBShare");
    if(tdFBShare)
        tdFBShare.innerHTML = "";
    if(tdInviteFriends)
        tdInviteFriends.innerHTML = "";
}

if(document.getElementById("searchheader")){
    document.getElementById("searchheader").addEventListener('keyup', function(e) {
        if(e.which == 13) {
            _gaq.push(['_trackEvent', 'search', 'search', document.getElementById("searchheader").value]);
            if(isPizapBook){
                top.location.href='//apps.facebook.com/' + fbNamespace + "/search/" + encodeURI(document.getElementById("searchheader").value);
            }else{
                window.location.href = "/search/" + encodeURI(document.getElementById("searchheader").value);
            }
        }
    });
}
if(document.getElementById("goheader")){
    document.getElementById("goheader").addEventListener('click', function(e) {
        if(isPizapBook){
            top.location.href='//apps.facebook.com/' + fbNamespace + "/search/" + encodeURI(document.getElementById("searchheader").value);
        }else{
            window.location.href = "/search/" + encodeURI(document.getElementById("searchheader").value);
        }
    });
}

if(document.getElementById("searchtags")){
    document.getElementById("searchtags").onkeypress = function(e) {
        if(e.which == 13) {
            if(isPizapBook){
                top.location.href='//apps.facebook.com/' + fbNamespace + "/search/" + encodeURI(document.getElementById("searchtags").value);
            }else{
                window.location.href = "/search/" + encodeURI(document.getElementById("searchtags").value);
            }
        }
    };
}
if(document.getElementById("go")){
    document.getElementById("go").onclick = function(){
        if(isPizapBook){
            top.location.href='//apps.facebook.com/' + fbNamespace + "/search/" + encodeURI(document.getElementById("searchtags").value);
        }else{
            window.location.href = "/search/" + encodeURI(document.getElementById("searchtags").value);
        }
    };
}

function enableMyPizapShareButtons(){
    if(document.getElementById("shareBtnMyPizap")){
        document.getElementById("shareBtnMyPizap").onclick = function() {
            var sel = document.getElementById("shareDropdownMyPizap");
            var pos = document.getElementById("shareBtnMyPizap");
            if (!isVisible(sel)) {
                sel.style.top = findPos(pos)[1] + 30 + "px";
                sel.style.left = (findPos(pos)[0] - 67) + "px";
                sel.style.display = "block";
            } else {
                sel.style.display = "none";
            }
        };
    }
    enablePopupShareButtons();
}

//FB Functions
function logout(){
    try{
        FB.init({
            appId: fbAppId,
            cookie: true,
            xfbml: true,
            oauth: true,
            status: true,
            version: 'v2.9'
        });
    }catch(err){}
    FB.getLoginStatus(checkLogoutStatus);
    _gaq.push(['_trackEvent', 'user', 'logout']);

}
function checkLogoutStatus(response) {
    if (response.status === "connected")
    {
        FB.logout(function(){top.location.href = "/logout";});
    }else
    {
        top.location.href = "/logout";
    }
}

function click_iPad()
{
    _gaq.push(['_trackEvent', 'mobile', 'ipad']);

    window.open("http://itunes.apple.com/us/app/pizap/id642936943","_self");
}

function close_iPad()
{
    var divipad = document.getElementById("divipad");
    var diviphone = document.getElementById("diviphone");
    if(divipad && diviphone)
    {
        divipad.style.display = "none";
        diviphone.style.display = "none";
    }
}

function close_android()
{
    document.getElementById("divandroid").style.display = "none";
}

function delete_thumb(obj){
    var answer = confirm("Are you sure you want to Delete this photo?")
    if (answer) {
        var ifDeleteImage = document.getElementById("ifDeleteImage");
        if (ifDeleteImage) {
            _gaq.push(['_trackEvent', 'image', 'delete', obj]);

            ifDeleteImage.src = '/delete_image?image_name=' + obj;
            model.imageList.remove(obj);
        }
    }
}
var needsPush = true;
function populatePopup(imageName, imgObj){

    imageName = imageName.replace(".jpg","");
    var popup = document.getElementById("popup");
    var url = "/image/" + imageName + "/popup";
    var xhr= new XMLHttpRequest();
    xhr.open('GET', url, true);
    xhr.onreadystatechange= function() {
        if (this.readyState!==4) return;
        if (this.status!==200) return; // or whatever error handling you want
        popup.style.position = 'absolute';
        popup.style.width = '100%';
        popup.style.top = getScrollTop() + 'px';
        popup.innerHTML= this.responseText;
        replaceScriptsRecurse(popup);

        var parent = imgObj;
        if(!hasClass(parent, "itemwrapper") && !hasClass(parent, "listWrapper")){
            while(true){
                parent = parent.parentNode;
                if(hasClass(parent, "itemwrapper") || hasClass(parent, "listWrapper")){
                    break;
                }
            }
        }

        var nextObj = parent.nextElementSibling;

        if(nextObj && (hasClass(nextObj, "itemwrapper") || hasClass(nextObj, "listWrapper"))){
            var image_name = nextObj.getAttribute("data-imagename");
            if(image_name == undefined){
                document.getElementById("nextObj").style.visibility = "hidden";
            }else{
                document.getElementById("nextObj").style.visibility = "visible";
                document.getElementById("nextObj").onclick = function(e){
                    populatePopup(image_name, nextObj);
                };
            }
        }else{
            document.getElementById("nextObj").style.visibility = "hidden";
        }
        var priorObj = parent.previousElementSibling;

        if(priorObj && (hasClass(priorObj, "itemwrapper") || hasClass(priorObj, "listWrapper"))){
            var image_name2 = priorObj.getAttribute("data-imagename");
            if(image_name2 == undefined){
                document.getElementById("priorObj").style.visibility = "hidden";
            }else{
                document.getElementById("priorObj").style.visibility = "visible";
                document.getElementById("priorObj").onclick = function(e){
                    populatePopup(image_name2, priorObj);
                };
            }
        }else{
            document.getElementById("priorObj").style.visibility = "hidden";
        }

    };
    xhr.send();

    popup.style.display = "block";
    if (navigator.appName != 'Microsoft Internet Explorer') {
        if (needsPush) {
            history.pushState(imageName, "piZap", '/image/' + imageName);
            needsPush = false;
        } else {
            history.replaceState(imageName, "piZap", '/image/' + imageName);
        }
    }

    return false;
}
function replaceScriptsRecurse(node) {
    if ( nodeScriptIs(node) ) {
        var script  = document.createElement("script");
        script.text = node.innerHTML;

        node.parentNode.replaceChild(script, node);
    }
    else {
        var i        = 0;
        var children = node.childNodes;
        while ( i < children.length) {
            replaceScriptsRecurse( children[i] );
            i++;
        }
    }

    return node;
}
function nodeScriptIs(node) {
    return node.getAttribute && node.getAttribute("type") == "text/javascript";
}


function enableMyPizapShareButtons(){
    if(document.getElementById("shareBtnMyPizap")){
        document.getElementById("shareBtnMyPizap").onclick = function() {
            var sel = document.getElementById("shareDropdownMyPizap");
            var pos = document.getElementById("shareBtnMyPizap");
            if (!isVisible(sel)) {
                sel.style.top = findPos(pos)[1] + 30 + "px";
                sel.style.left = (findPos(pos)[0] - 67) + "px";
                sel.style.display = "block";
            } else {
                sel.style.display = "none";
            }
        };
    }
    enablePopupShareButtons();
}
function findPos(obj) {
    var curleft = curtop = 0;
    if (obj.offsetParent) {
        do {
            curleft += obj.offsetLeft;
            curtop += obj.offsetTop;
        } while (obj = obj.offsetParent);
        return [curleft,curtop];
    }
}


function showHeaderMenu(){
    var sel = document.getElementById("headerDropdown");
    var pos = document.getElementById("accountMenu");
    if (!isVisible(sel)) {
        sel.style.top = findPos(pos)[1] + 40 + "px";
        sel.style.left = (findPos(pos)[0] - 27) + "px";
        sel.style.display = "block";
        window.setTimeout(function() {
            var sel = document.getElementById("headerDropdown");
            if (isVisible(sel)) {
                sel.style.display = "none";
            }
        }, 5000);
    } else {
        sel.style.display = "none";
    }
}
function getScrollTop() {
    if (typeof pageYOffset!= 'undefined'){
        //most browsers except IE before #9
        return pageYOffset;
    }

    var B= document.body; //IE 'quirks'
    var D= document.documentElement; //IE with doctype
    D= (D.clientHeight)? D: B;

    return D.scrollTop;
}
function enablePopupShareButtons(){

    if(document.getElementById("shareBtn")){
        document.getElementById("shareBtn").onclick = function() {
            var sel = document.getElementById("popupShareDropdown");

            if (! isVisible(sel)) {
                var btnPos = this.getBoundingClientRect();
                sel.style.display = "block";

                var dnWidth = sel.clientWidth;
                var dnHeight = sel.clientHeight;

                var n = this.parentNode;
                var top = 0;
                while (n) {
                    if (n.getAttribute('id') == 'popup') {
                        break;
                    }
                    n = n.parentNode;
                    top += n.clientTop;
                }

                sel.style.top = Math.ceil(top + dnHeight + 8) + "px";
                sel.style.left = Math.ceil((btnPos.left - (dnWidth / 2) + (btnPos.width / 2) )) + "px";
            } else {
                sel.style.display = "none";
            }
        };
    }
    if(document.getElementById("aEmail")){
        document.getElementById("aEmail").onclick = function(){
            var sel = document.getElementById("divEmail");
            var pos = document.getElementById("aEmail");
            if (!isVisible(sel)) {
                sel.style.top = findPos(pos)[1]  + "px";
                sel.style.left = (findPos(pos)[0] - 355) + "px";
                sel.style.display = "block";
            } else {
                sel.style.display = "none";
            }
            return false;
        };
    }
    if(document.getElementById("aEmbed")){
        document.getElementById("aEmbed").onclick = function(){
            var sel = document.getElementById("divEmbed");
            var pos = document.getElementById("aEmbed");
            if (!isVisible(sel)) {
                sel.style.top = findPos(pos)[1]  + "px";
                sel.style.left = (findPos(pos)[0] - 415) + "px";
                sel.style.display = "block";
            } else {
                sel.style.display = "none";
            }
            _gaq.push(['_trackEvent', 'image', 'embed']);

            return false;
        };
    }
}

function like(image, likeObj){
    if(username == ""){
        PizapLogin.showLoginDialog();
        return false;
    }
    xmlhttp=new XMLHttpRequest();
    xmlhttp.open("POST",'/like/' + image,true);
    xmlhttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded; charset=UTF-8");
    xmlhttp.send();

    _gaq.push(['_trackEvent', 'image', 'like', image]);

    if(hasClass(likeObj, "liked")){
        removeClass(likeObj, "liked");
        //addClass(likeObj, "liked");

        text = likeObj.getElementsByTagName("span")[0].innerHTML;
        num = text.match(/\d+\.?\d*/g);
        if(num != null){
            count = parseInt(num);
            likeObj.getElementsByTagName("span")[0].innerHTML = "Like " + (count - 1);
        }
    }else{
        //removeClass(likeObj, "tsc_c3b_white");
        addClass(likeObj, "liked");
        text = likeObj.getElementsByTagName("span")[0].innerHTML;
        num = text.match(/\d+\.?\d*/g);
        if(num != null){
            count = parseInt(num);
            likeObj.getElementsByTagName("span")[0].innerHTML = "Like " + (count + 1);
        }
    }

}
function likeuser(user, likeObj){
    if(username == ""){
        PizapLogin.showLoginDialog();
        return false;
    }
    xmlhttp=new XMLHttpRequest();
    xmlhttp.open("POST",'/likeuser/' + user,true);
    xmlhttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded; charset=UTF-8");
    xmlhttp.send();

    _gaq.push(['_trackEvent', 'user', 'like', user]);

    if (hasClass(likeObj, "liked")){
        removeClass(likeObj, "liked");
        text = likeObj.getElementsByTagName("span")[0].innerHTML;
        count = parseInt(text.match(/\d+\.?\d*/g));
        count = isNaN(count) ? 1: count;
        likeObj.getElementsByTagName("span")[0].innerHTML = "Like " + (count - 1);
    } else {
        addClass(likeObj, "liked");
        text = likeObj.getElementsByTagName("span")[0].innerHTML;
        count = parseInt(text.match(/\d+\.?\d*/g));
        count = isNaN(count) ? 0: count;
        likeObj.getElementsByTagName("span")[0].innerHTML = "Like " + (count + 1);
    }
}
function deleteImage(image, link){
    if (username == ""){
        PizapLogin.showLoginDialog();
        return false;
    }
    if (link != null){
        var parent = link;
        try {
            while(true){
                parent = parent.parentNode;
                var className = parent.getAttribute('class');
                if (className && (className.indexOf('itemwrapper') !== -1 || className.indexOf('listWrapper') !== -1)) {
                    break;
                }
            }
            parent.parentNode.removeChild(parent);
            if (typeof msnry !== 'undefined') {
                msnry.layout();
            }
        } catch(e) { console && console.log(e); }
    }
    xmlhttp=new XMLHttpRequest();
    xmlhttp.onload = function (){
        if (link == null){
            if (isPizapBook){
                top.location.href='//apps.facebook.com/' + fbNamespace + "/gallery/mypizap";
            } else {
                window.location.href = "/gallery/mypizap";
            }
        }
    };
    xmlhttp.open("POST","/delete/" + image,true);
    xmlhttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded; charset=UTF-8");
    xmlhttp.send();
    _gaq.push(['_trackEvent', 'image', 'delete', image]);
}

function repostPhoto(image, repostObj) {
    if(username == ""){
        PizapLogin.showLoginDialog();
        return false;
    }
    xmlhttp=new XMLHttpRequest();
    xmlhttp.open("POST","/repost/" + image,true);
    xmlhttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded; charset=UTF-8");
    xmlhttp.send();

    _gaq.push(['_trackEvent', 'image', 'repost', image]);

    if(hasClass(repostObj, "reposted")){
        removeClass(repostObj, "reposted");
        //addClass(repostObj, "tsc_c3b_white")

        text = repostObj.getElementsByTagName("span")[0].innerHTML;
        num = text.match(/\d+\.?\d*/g);
        if(num != null){
            count = parseInt(num);
            repostObj.getElementsByTagName("span")[0].innerHTML = "Like " + (count - 1);
        }
    }else{
        //removeClass(repostObj, "tsc_c3b_white");
        addClass(repostObj, "reposted")
        text = repostObj.getElementsByTagName("span")[0].innerHTML;
        num = text.match(/\d+\.?\d*/g);
        if(num != null){
            count = parseInt(num);
            repostObj.getElementsByTagName("span")[0].innerHTML = "Repost " + (count + 1);
        }
    }

}
function sendEmail(current_image) {
    var myData = "recipName=" + encodeURIComponent(document.getElementById("recipName").value) + "&recipEmail=" + encodeURIComponent(document.getElementById("recipEmail").value) + "&recipMessage=" + encodeURIComponent(document.getElementById("taEmailMessage").value) + "&url=" + encodeURIComponent(current_image);
    getJSON('/emailFriend', 'POST', myData, function(){
        var divEmail = document.getElementById("divEmail");
        if(divEmail)
            divEmail.style.display = "none";
    });
}


function follow_click(type, new_user_id, location) {
    var tdUserCounts123 = document.getElementById(location);
    if (tdUserCounts123) {
        var divFollowing = document.getElementById("divFollowing");
        divFollowing.style.top = (findPos(tdUserCounts123)[1] + 40) + "px";
        divFollowing.style.left = (findPos(tdUserCounts123)[0] - 350) + "px";
        divFollowing.style.display = "block";
        var divFollowingSecondary = document.getElementById("divFollowing_secondary");
        divFollowingSecondary.innerHTML = "";
        if (divFollowing) {
            _gaq.push(['_trackEvent', 'user', 'follow', new_user_id]);

            var loadUrl = ""
            loadUrl = "/svc/mypizap_follow" + type + "?&u=" + new_user_id;
            getJSON(loadUrl, 'GET', null, function(data){
                var apendString = "";
                if (data) {
                    var subscribeCounter = 0;
                    var isData = false;
                    //console.log("data returned");
                    for (index = 0; index < data.length; ++index){
                        var follow_user_id = data[index].u;
                        var name = data[index].n;
                        var pizapCount = data[index].pizapCount;
                        var pointCount = data[index].pointCount;
                        var followerCount = data[index].followerCount;
                        var profileImage = data[index].profileImage;
                        var fb_user_id = data[index].fb_user_id;
                        newDiv = '<div style="padding-bottom:8px;margin-bottom:8px;width:380px;border-bottom-style:solid;border-bottom-color:#CCC;border-bottom-width:1px">';
                        newDiv += '<table width="380px" border="0" cellspacing="0" cellpadding="0">';
                        newDiv += '<tr>';
                        newDiv += '<td width="14%"><a href="/u/' + follow_user_id + '" class="imageborder"><img src="' + profileImage + '" alt="" name="imgProfile123" width="50" height="50" hspace="4" id="imgProfile123" /></a></td>';
                        newDiv += '<td width="58%"><div class="image_display_username" style="padding-bottom:3px;font-size:18px; padding-top:0px"><a href="/u/' + follow_user_id + '" >' + name + '</a><br>';
                        newDiv += '<span class="smallgrey"><strong>' + pizapCount + '</strong><a href="/u/' + follow_user_id + '"> pizaps</a> - <strong>' + followerCount + '</strong> followers - <strong>' + pointCount + '</strong> piontZ</span></div></td>';
                        if(data[index].following == true){
                            newDiv += '<td width="28%"><div style="float:right"><a class="follow_button tsc_c3b_small tsc_c3b_grey tsc_button" style="margin-left: 5px;" nohref onclick="follow_user(\'' + follow_user_id + '\', this);"><img src="//cdn.pizap.com/pizapfiles/images/follow-icon-2013.png" style="vertical-align: text-top; margin-right: 5px;" border="0"><span>Unfollow</span></a></div> </td>';
                        }else{
                            newDiv += '<td width="28%"><div style="float:right"><a class="follow_button tsc_c3b_small tsc_c3b_white tsc_button" style="margin-left: 5px;" nohref onclick="follow_user(\'' + follow_user_id + '\', this);"><img src="//cdn.pizap.com/pizapfiles/images/follow-icon-2013.png" style="vertical-align: text-top; margin-right: 5px;" border="0"><span>Follow</span></a></div> </td>';
                        }
                        newDiv += '</tr>';
                        newDiv += '</table>';
                        newDiv += ' </div>';
                        apendString = apendString + newDiv;
                        subscribeCounter++
                    }
                }
                divFollowingSecondary.innerHTML = apendString;
            });
        }
    }
    return false;
}


function follow_user(user_id, followObj) {
    if (username == ""){
        PizapLogin.showLoginDialog();
        return false;
    }
    if (hasClass(followObj, "btn-green")){
        removeClass(followObj,"btn-green");
        // addClass(followObj, "tsc_c3b_white")

        text = followObj.getElementsByTagName("span")[0].innerHTML;
        followObj.getElementsByTagName("span")[0].innerHTML = "Follow";
    } else {
        // removeClass(followObj,"tsc_c3b_white");
        addClass(followObj,"btn-green")
        text = followObj.getElementsByTagName("span")[0].innerHTML;
        followObj.getElementsByTagName("span")[0].innerHTML = "Unfollow";
    }

    xmlhttp=new XMLHttpRequest();
    xmlhttp.open("POST","/follow/" + user_id,true);
    xmlhttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded; charset=UTF-8");
    xmlhttp.send();
    _gaq.push(['_trackEvent', 'user', 'follow', user_id]);
}

function imgResize(){
    var height = window.innerHeight|| document.documentElement.clientHeight || document.body.clientHeight;
    var width = window.innerWidth || document.documentElement.clientWidth || document.body.clientWidth;
    var imgMain = document.getElementById("imgMain");

    if (height < imgMain.height + 86) {
        imgMain.style.height = (height - 86) + "px";
    }else{
        if (width < imgMain.width + 390) {
            imgMain.style.width = (width - 390) + "px";
        }
    }
    try{
        commentHeight = imgMain.height - 520;
        if(commentHeight < 300)
            commentHeight = 300;

        var comments = document.getElementsByClassName("comments");
        if(comments && comments[0])
            comments[0].style.maxHeight = commentHeight + "px";

    }catch(e){}
}


//Upgradez
var upgrade_type_id = 0;
function purchase(type_id, cost, current_points, objCount) {
    var button = document.getElementById("getIt" + objCount);
    var pos = findPos(button);
    var posy = pos[1] - 75;

    if (current_points >= cost) {
        upgrade_type_id = type_id;
        var divP = document.getElementById('divPurchase');
        divP.style.visibility = "visible";
        divP.style.top = posy + 'px';
        var divT = document.getElementById('divUpgradeText');
        divT.innerHTML = "Are you sure you want to spend<br /> " + cost + " piZap pointZ on this upgrade?";
    }
    else {
        var divN = document.getElementById('divNoPoints');
        divN.style.visibility = "visible";
        divN.style.top = posy + 'px';
    }
}

function closeDiv(element) {
    var divP = document.getElementById(element);
    divP.style.visibility = "hidden";
}

function redirect() {
    if(isPizapBook){
        top.location.href='//apps.facebook.com/' + fbNamespace + "/upgrade_thank_you?type_id=" + upgrade_type_id;
    }else{
        window.location = "/upgrade_thank_you?type_id=" + upgrade_type_id;
    }
}


function makePublic(image_name, isPublic, publicObj) {
    xmlhttp=new XMLHttpRequest();
    xmlhttp.onload = function (){
        _gaq.push(['_trackEvent', 'image', 'public', image_name]);

        var tdUserCounts = document.getElementById("tdUserCounts");
        if (isPublic == true) {
            tempDiv = document.createElement('div');
            tempDiv.innerHTML = "<a class=\"tsc_c3b_small tsc_c3b_white tsc_button\" nohref onclick=\"makePublic('" + image_name + "',false, this);\"><img src='//cdn.pizap.com/pizapfiles/images/lock-icon.png' align='absmiddle'/><span>Make Private</span></a>";
            publicObj.parentNode.replaceChild(tempDiv.childNodes[0], publicObj);
        } else {
            tempDiv = document.createElement('div');
            tempDiv.innerHTML = "<a class=\"tsc_c3b_small tsc_c3b_white tsc_button\" nohref onclick=\"makePublic('" + image_name + "',true, this);\"><span>Make Public</span></a>";
            publicObj.parentNode.replaceChild(tempDiv.childNodes[0], publicObj);
        }
    };
    xmlhttp.open("POST","/image/" + image_name + "/permission",true);
    xmlhttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded; charset=UTF-8");
    xmlhttp.send("isPublic=" + isPublic);

    return true;
}
function inviteFriends(){
    FB.ui({
        method: 'send',
        name: 'Photo Editor & Collage Maker',
        link: 'http://www.pizap.com',
        picture: 'http://cdn.pizap.com/pizapfiles/icons/512x512.png'
    });
    _gaq.push(['_trackEvent', 'social', 'invitefriends']);
}
function changeTheme(r, g, b, image){
    var pixelColor = "rgb(" + r + ", " + g + ", " + b + ")";
    var preview = document.getElementById('preview');
    if(preview){
        preview.style.backgroundColor = pixelColor;
    }
    var galleryBody = document.getElementById("galleryBody");
    var style = "" + r + "," + g + "," + b + ",";
    if(image != null && image != ""){
        backgroundImage = image;
        var isFirefox = typeof InstallTrigger !== 'undefined';
        if(image.indexOf(".jpg") == -1){
            image = "//static.pizap.com/pizapfiles/themes/" + image + ".jpg";
        }
        var style = "" + r + "," + g + "," + b + "," + image;
        if(galleryBody){
            galleryBody.style.backgroundColor = "rgb(" + r + ", " + g + ", " + b + ")";
            if (navigator.userAgent.match(/MSIE 1/i)) {
                galleryBody.style.background = "-ms-linear-gradient(top, rgba(" + r + ", " + g + ", " + b + ",0) 0%,rgb(" + r + ", " + g + ", " + b + ") 420px,rgb(" + r + ", " + g + ", " + b + ") 100%),url('" + image + "') repeat-x";
                galleryBody.style.background = "linear-gradient(to bottom, rgba(" + r + ", " + g + ", " + b + ", 0) 0%, rgb(" + r + ", " + g + ", " + b + ") 420px, rgb(" + r + ", " + g + ", " + b + ") 100%),url('" + image + "') repeat-x";
            }else if(navigator.userAgent.match(/Chrome/i)){
                galleryBody.style.background = "linear-gradient(to bottom, rgba(" + r + ", " + g + ", " + b + ", 0) 0%, rgb(" + r + ", " + g + ", " + b + ") 420px, rgb(" + r + ", " + g + ", " + b + ") 100%),url('" + image + "') repeat-x";
            }else if(navigator.userAgent.match(/Safari/i)){
                galleryBody.style.background = "-webkit-gradient(linear, left top, left bottom, color-stop(0%,rgba(" + r + ", " + g + ", " + b + ",0)), color-stop(420px,rgb(" + r + ", " + g + ", " + b + ")), color-stop(100%,rgb(" + r + ", " + g + ", " + b + "))),url('" + image + "') repeat-x";
                galleryBody.style.background = "-webkit-linear-gradient(top, rgba(" + r + ", " + g + ", " + b + ",0) 0px,rgb(" + r + ", " + g + ", " + b + ") 420px,rgb(" + r + ", " + g + ", " + b + ") 100%), url('" + image + "') repeat-x";
            }else if(isFirefox){
                galleryBody.style.background = "-moz-linear-gradient(top, rgba(" + r + ", " + g + ", " + b + ",0) 0px,rgb(" + r + ", " + g + ", " + b + ") 420px,rgb(" + r + ", " + g + ", " + b + ") 100%), url('" + image + "') repeat-x";
            }else{
                galleryBody.style.background = "linear-gradient(to bottom, rgba(" + r + ", " + g + ", " + b + ", 0) 0%, rgb(" + r + ", " + g + ", " + b + ") 420px, rgb(" + r + ", " + g + ", " + b + ") 100%),url('" + image + "') repeat-x";
            }
        }
    } else if (r != 0){
        backgroundImage = null;
        if(galleryBody){
            galleryBody.style.background = "rgb(" + r + ", " + g + ", " + b + ")";
        }
    }else{
        backgroundImage = null;
        if(galleryBody){
            galleryBody.style.background = "#e1e1e4";
        }
    }
    var myData = "style=" + style;
    if(image == "")
        myData = "style=";

    xmlhttp=new XMLHttpRequest();
    xmlhttp.onload = function (){
        if(isPizapBook){
            top.location.href='//apps.facebook.com/' + fbNamespace + '/gallery/mypizap?duration=account';
        }else{
            window.location='/gallery/mypizap?duration=account';
        }
    };
    xmlhttp.open("POST",'/myaccount_style',true);
    xmlhttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded; charset=UTF-8");
    xmlhttp.send(myData);
    _gaq.push(['_trackEvent', 'user', 'changetheme']);

}
function showCommentDropdown(thumbObj, imagename) {
    if(username == ""){
        PizapLogin.showLoginDialog();
        return false;
    }

    var sel = document.getElementById("commentDropdown");
    var btnPos = thumbObj.getBoundingClientRect();

    if (!isVisible(sel)) {
        // sel.style.top = (pos[1] + 17) + "px";
        // sel.style.left = (pos[0] - 75) + "px";
        sel.style.display = "block";

        var dnWidth = sel.clientWidth;
        var dnHeight = sel.clientHeight;

        sel.style.top = (getScrollTop() + btnPos.top + btnPos.height + 8) + "px";
        sel.style.left = (btnPos.left - (dnWidth / 2) + (btnPos.width / 2) ) + "px";

        var commentText = document.getElementById("commentText");
        if(commentText){
            commentText.focus();
            commentText.onkeyup = null;
            commentText.onkeydown = function(e){
                var code = (e.keyCode ? e.keyCode : e.which);
                if (code == 13) { //Enter keycode
                    e.preventDefault();
                    e.stopPropagation();
                    commentText.setAttribute('disabled', 'true');

                    xmlhttp=new XMLHttpRequest();
                    xmlhttp.onload = function (){
                        commentText.value = '';
                        commentText.removeAttribute('disabled');
                        _gaq.push(['_trackEvent', 'image', 'addcomment']);
                    };
                    xmlhttp.open("POST","/comment",true);
                    xmlhttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded; charset=UTF-8");
                    xmlhttp.send("imageName=" + imagename + "&comment=" + commentText.value);
                    sel.style.display = "none";
                }
            }
        }
    } else {
        sel.style.display = "none";
    }
}
function centerImage(imgObj, finalheight, finalwidth){
    if(imgObj.clientWidth > imgObj.clientHeight){
        imgObj.height(finalheight);
        newWidth = (imgObj.clientWidth / imgObj.clientHeight) * finalwidth;
        imgObj.width(newWidth)
        imgObj.css({
            left: ((finalwidth - newWidth) / 2)  + "px"
        });
    }else{
        imgObj.width(finalwidth);
        newHeight = (imgObj.clientHeight / imgObj.clientWidth) * finalheight;
        imgObj.height(newHeight)
        imgObj.css({
            top: ((finalheight - newHeight) / 2) + "px"
        });
    }

    var commentText = document.getElementById("commentText");
    if(commentText)
        commentText.innerHTML = "";
}
function deleteComment(ImageName, Created, deleteObj){

    xmlhttp=new XMLHttpRequest();
    xmlhttp.onload = function (){
        cb = deleteObj.parentNode;
        cb.parentNode.removeChild(cb);
        _gaq.push(['_trackEvent', 'image', 'deletecomment']);
    };
    xmlhttp.open("DELETE","/comment/" + ImageName + "/" + Created,true);
    xmlhttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded; charset=UTF-8");
    xmlhttp.send();
}

function sharePizap(){
    window.open('https://www.facebook.com/sharer.php?s=100' +
        '&p[url]=http%3A%2F%2Fwww.pizap.com%2Fpizap' +
        '&p[title]=' + encodeURIComponent('Photo Editor & Collage Maker') +
        '&p[images][0]=' + encodeURIComponent('http://cdn.pizap.com/pizapfiles/icons/512x512.png') +
        '&p[summary]=' + encodeURIComponent('Check out piZap.com! PiZap is the fun and easy way to add effects, stickers and borders to your pics. It also has a great collage feature and a cut-out tool.'),
        'sharer', 'toolbar=0,status=0,width=580,height=325');
}

function logEvent(eventName){
    try {
        xmlhttp = new XMLHttpRequest();
        xmlhttp.open("GET", "/log/" + eventName, true);
        xmlhttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded; charset=UTF-8");
        xmlhttp.send();
    }catch(e){
        console.log("error logging event name " + e.message);
    }
}

function logMessage(message){
    console.log(message);
}

//EDITOR Functions
function fbLoggedIn()
{
    FB.getLoginStatus(PizapLogin.handleFBLoginResponse);

    var flashMovie=getFlashMovieObject("flashContent");
    if(flashMovie){
        try{
            getJSON("/me", 'GET', null, function(data){
                if (data) {
                    username = data.UserName;
                }
            });
        }catch(e){}
    }
}

function showTwitter(){PizapLogin.showTwitter();}

function showInstagram(){window.open("/instagram/login?flash=true",'','width=800,height=500');}

function showTumblr(){window.open("/tumblr/login?flash=true",'','width=800,height=500')}

function setTumblrAuthData(username)
{
    var flashMovie=getFlashMovieObject("flashContent");
    try{
        flashMovie.tumblrAuthenticated(username);
    }catch(e){}
}

function setInstagramAuthData(username)
{
    var flashMovie=getFlashMovieObject("flashContent");
    try{
        flashMovie.instagramAuthenticated(username);
    }catch(e){}
}

function getFlashMovieObject(movieName){
    if (window.document[movieName]){
        return window.document[movieName];
    }
    if (navigator.appName.indexOf("Microsoft Internet")==-1){
        if (document.embeds && document.embeds[movieName])
            return document.embeds[movieName];
    }
    else{
        return document.getElementById(movieName);
    }
}

function sharePizap(){
    window.open('https://www.facebook.com/sharer.php?s=100' +
        '&p[url]=http%3A%2F%2Fwww.pizap.com%2Fpizap' +
        '&p[title]=' + encodeURIComponent('Photo Editor & Collage Maker') +
        '&p[images][0]=' + encodeURIComponent('http://cdn.pizap.com/pizapfiles/icons/512x512.png') +
        '&p[summary]=' + encodeURIComponent('Check out piZap.com! PiZap is the fun and easy way to add effects, stickers and borders to your pics. It also has a great collage feature and a cut-out tool.'),
        'sharer', 'toolbar=0,status=0,width=580,height=325');
}

function hasClass(obj, selector){
    var className = " " + selector + " ";
    return (" " + obj.className + " ").replace(/[\n\t]/g, " ").indexOf(className) > -1;
}

function addClass(obj, selector){
    obj.classList.add(selector);
}
function removeClass(obj, selector){
    obj.classList.remove(selector);
}
function _pizap(id) {
    if (id) {
        if (window === this) {
            return new _pizap(id);
        }
        this.e = document.getElementById(id);
        return this;
    } else {
        return null;
    }
}
function learnMore(event) {
    var url = '/pro_details';
    var win = window.open(url, '_blank');
}
function buyPro(){
    var radios = document.getElementsByName('proplan');

    for (var i = 0, length = radios.length; i < length; i++) {
        if (radios[i].checked) {
            purchasePRO(radios[i].value);
            break;
        }
    }
}
_pizap.prototype = {
    editable:	function () {
        if(this.e.innerHTML == null || this.e.innerHTML == ""){
            this.e.innerHTML = this.e.getAttribute('data-placeholder');
        }

        this.e.onclick = function(e){
            if(e.target != this){return;}
            var originalValue = this.innerHTML;
            if(originalValue == this.getAttribute('data-placeholder')){
                originalValue = "";
            }
            var parentElement = this;
            this.innerHTML = '<form><textarea name="value" style="height: 16px; width: 280px;">' + originalValue + '</textarea><button type="submit">OK</button><button type="cancel">cancel</button></form>';
            //this.innerHTML = '<input type="text" value="' + originalValue + '"><button onclick="_pizap(\'' + this.id + '\').saveEditable()">Save</button><button onclick="cancelEditable()">Cancel</button>';
            var form = this.childNodes[0];
            var textElement = form.childNodes[0];
            var okButton = form.childNodes[1];
            var cancelButton = form.childNodes[2];

            cancelButton.onclick = function(e){
                if(originalValue == ""){
                    parentElement.innerHTML = parentElement.getAttribute('data-placeholder');
                }else{
                    parentElement.innerHTML = originalValue;
                }
                e.preventDefault();
            };

            okButton.onclick = function(e){
                if(textElement.value == ""){
                    parentElement.innerHTML = parentElement.getAttribute('data-placeholder');
                }else{
                    parentElement.innerHTML = textElement.value;
                }
                e.preventDefault();
                var myData = 'id=' + parentElement.id + '&value='+encodeURIComponent(textElement.value);
                xmlhttp=new XMLHttpRequest();
                xmlhttp.open("POST",parentElement.getAttribute('data-post'),true);
                xmlhttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded; charset=UTF-8");
                xmlhttp.send(myData);
            }
        };
        return this;
    }
};
